' -------  CREATE_INDEX.VBS --------
'  Version: 25.05.2003
'
' Kleines VB-Script, das einen HTML-Index aller JPG-Files eines Verzeichnisses "thumbnails" erstellt.
' (W) 10.2000, Sebastian und Henning Stcklein
'
' Die Thumbnail-Bilder mssen den Bilddateinamen "*.jpg" mit Ergnzung "_t.jpg" besitzen,
' wie er z.B. von Irfanview32 generiert wird.
' Fr die Datumsfunktionen wird ein Bilddateiformat "yymmdd-hhmmss*.jpg" vorausgesetzt,
' das z.B. vom VBS-Script "_rename.vbs" generiert wird.
'
' Vorgehensweise:
'  a) Thumbnail-Verzeichnis nach allen Dateien "*_t.jpg" abscannen und deren Namen merken
'  b) Dabei (aus den Dateinamen heraus) das frheste und spteste Datum ermitteln
'  c) Dateinamen alphabetisch sortieren (VB verwrfelt sonst gelegentlich die Reihenfolge)
'  d) ein Verzeichnis hher "_picindex.html" anlegen, im Header Anzahl und Datum der Files vermerken
'  e) fr jede gefundene Thumbnail-Datei ein Thumbnail einbinden mit Link auf die Dateien aus e)
'  f) fr jede gefundene Thumbnail-Datei im Thumbnail-Verzeichnis eine Sub-HTML-Datei anlegen mit
'      Einbindung des Original-Bildes. Die Gre wird dynamisch skaliert ber ein selbstmodifierendes Java-Script.
'      Auf das vorige und nchste Bild (sofern vorhanden) wird ein Link auf dessen Sub-HTML-Datei eingebunden,
'      auerdem ein Link auf das Index-Script selbst.
'  g) Zum Schlu nach gleichnamigen .AVI/.MOV und .JPG-Dateien suchen und ggf. je ein Thumbnail mit direktem Link
'     auf das AVI in _picindex.html anlegen

Dim TextStream, HtmlStream
Dim chTab, chNL, chHK
Dim strDate, strMinDate, strMaxDate
Dim strIndexName, strTempName
Dim strDummyPic, strLeftPic, strRightPic, strZoomPic, strIndexPic
Dim strAnz, strMissing, strAvi
Dim strThumbPath, strPicPath, strIndexPath

strThumbPath = "thumbnails"
strPicPath   = "."
strIndexPath = "../../index"
strIndex1Path = "../index"
strIndexName = "_picindex.html"

' Die 3 Button-GIFs fr die Sub-HTMLs sollten im selben Verzeichnis wie "_picindex.html" liegen,
' ansonsten hier die Adressierung absolut oder relativ zum Thumbnail-Ordner angeben
strDummyPic = strIndexPath & "/b_dummy.gif"
strLeftPic = strIndexPath & "/b_left.gif"
strRightPic = strIndexPath & "/b_right.gif"
strZoomPic = strIndexPath & "/b_zoom.gif"
strIndexPic = strIndexPath & "/b_index.gif"

strMaxDate = "00000000"
strMinDate = "99999999"

chTab = chr(9)
chNL  = chr(10)
chHK  = chr(34)

Set FS = CreateObject("Scripting.FileSystemObject")

Set fThumbFolder = FS.GetFolder(strThumbPath)
Set fThumbFiles = fThumbFolder.Files

Set fPicFolder = FS.GetFolder(strPicPath)
Set fPicFiles = fPicFolder.Files


' Dim strDebugName
' strDebugName = "debug.txt"
' Set fDebug = fPicFolder.CreateTextFile (strDebugName)

Dim strArray(2000)
Dim strSorted(2000)

' Das Thumbnail-Verzeichnis nach Bildern abscannen,
' damit Anzahl und alle Namen vorab bekannt sind.
bMissing = 0 
i = 1
For Each fFile in fThumbFiles

' Neues Irfanview-Thumbnail-Format korrigieren
'  if (LCase(Right(fFile.Name, 10)) = ".jpg_t.jpg") Then    
'    strArray(i) = (LEFT (fFile.Name, LEN(fFile.Name)-10) & ".jpg")
'    strTempName = (LEFT (fFile.Name, LEN(fFile.Name)-10) & "_t.jpg")
'    RENAME bfFile, strTempName
'    fFile.Name = strTempName
'  end if

  ' Ab hier intern immer altes Irfanview-Thumbnail-Format
  if (LCase(Right(fFile.Name, 6)) = "_t.jpg") Then 
    strArray(i) = (LEFT (fFile.Name, LEN(fFile.Name)-6) & ".jpg")

    ' Thumbnail nur erzeugen, wenn auch Originalbild vorhanden, sonst mitzhlen
    if (FS.FileExists (strArray(i))) then
       ' Datum Y2K-sicher umwandeln
       strDate = (LEFT (fFile.Name, 6))
       if (LEFT (strDate, 1) = "9") then
           strDate = "19" & strDate
       else
           strDate = "20" & strDate
       end if

       ' Wenn Dateiname mit "_rename.vbs"-Datum, dann frhestes und sptestes Datum merken
      if (Mid (strArray(i), 7, 1) = "-") then
          if (strComp (strDate, strMinDate, 1) = -1) then
              strMinDate = strDate
          end if
          if (strComp (strDate, strMaxDate, 1) = 1) then
              strMaxDate = strDate
          end if
       end if
        i = i + 1
    else
        bMissing = bMissing + 1
    end if

  end if
Next

strAnz = i-1
strMissing = bMissing


' Die Dateinamen umsortieren, in alphabetisch aufsteigende Reihenfolge bringen
for nSort = 1 to strAnz
   ' Den kleinsten Namen im unsortierten Array suchen
   nMerk = 0
   strMerk = strMinDate			' Dummy, grsser als sinnvolle Werte
   For j = 1 to strAnz
      if (StrComp (strArray(j), strMerk)) = -1 then
        nMerk = j
        strMerk = strArray(nMerk)
      end if
   Next
   ' Den gefundenen Namen ins sortierte Array einkopieren
   strSorted(nSort) = strMerk
   strArray(nMerk) = "9999"		' alten Eintrag berschreiben
Next


Set TextStream = fPicFolder.CreateTextFile (strIndexName)

' HTML-Header schreiben
TextStream.WriteLine ("<html>")
TextStream.WriteLine ("<head>")
TextStream.WriteLine ("<meta http-equiv=" & chHK & "Content-Type" & chHK & " content=" & chHK & "text/html; charset=iso-8859-1" & chHK & ">")
TextStream.WriteLine ("<meta name=" & chHK & "GENERATOR" & chHK & "content=" & chHK & "Hennings PicIndex-Generator" & chHK & ">")
TextStream.WriteLine ("<title>Pic-Index</title>")
TextStream.WriteLine ("<style>")
TextStream.WriteLine ("body {font-family:Verdana;}")
TextStream.WriteLine ("</style>")
TextStream.WriteLine ("</head>")
TextStream.WriteLine ("<body bgcolor=" & chHK & "#C0C0C0" & chHK & "background=" & chHK & "../index/bknd.jpg" & chHK & ">")
TextStream.WriteLine ("<center>")

' Start-Datum angeben
TextStream.Write ("<h1>" & Mid (strMinDate, 7, 2) & "." & Mid (strMinDate, 5, 2) & ".")

' Jahreszahl beim Start-Datum nur, wenn ungleich Ende-Datum oder alle Bilder vom gleichen Tag
if ((strComp (strMinDate, strMaxDate, 1) = 0) or (strComp (Left (strMinDate, 4), Left (strMaxDate, 4)) <> 0)) then
   TextStream.Write (Left (strMinDate, 4))
end if

' Ende-Datum angeben, sofern nicht alle Bilder vom selben Tag
if (strComp (strMinDate, strMaxDate, 1) <> 0) then
   TextStream.Write (" - ")
   TextStream.Write (Mid (strMaxDate, 7, 2) & "." & Mid (strMaxDate, 5, 2) & "." & Left (strMaxDate, 4))
end if
TextStream.Write (" (" & strAnz & " Bilder)")
TextStream.WriteLine ("</h1>")

' Rcksprung auf ..\index.html ermglichen
TextStream.WriteLine ("<FONT size = " & chHK & "-1" & chHK & ">")
TextStream.WriteLine ("<a href=" & chHK & "../index.html" & chHK & ">Zurck zur bersicht</a>")
TextStream.WriteLine ("<br><hr>")
TextStream.WriteLine ("Zum Vergrern aufs Bild klicken")
TextStream.WriteLine ("<br><br></FONT>")

' Fr jedes Bild einen HTML-Link in "_PicIndex.html" erstellen
For j = 1 To i-1
    Set fFile = FS.GetFile (strSorted(j))
    TextStream.Write ("<A HREF=" & chHK & strThumbPath & "\")
    TextStream.Write (LEFT (fFile.Name, LEN(fFile.Name)-4) & ".html")
    TextStream.Write (chHK & ">")
    TextStream.WriteLine (" ")

    TextStream.Write ("<IMG SRC=" & chHK)
    TextStream.Write (strThumbPath)
    TextStream.Write ("\")
    TextStream.Write (LEFT (fFile.Name, LEN(fFile.Name)-4) & "_t.jpg")
    TextStream.Write (chHK)

    TextStream.Write (" ALT=" & chHK)
    TextStream.Write (fFile.Name)
    TextStream.Write (" (" & fFile.Size & " Byte)")
    TextStream.Write (chHK)

    TextStream.WriteLine (" BORDER=" & chHK & "0" & chHK & "></A>")

     ' Fr jedes Bild eine Sub-HTML-Datei im Thumbnail-Ordner erzeugen
     Set HtmlStream = fThumbFolder.CreateTextFile (LEFT (fFile.Name, LEN(fFile.Name)-4) & ".html") 
     HtmlStream.WriteLine ("<HTML>  <HEAD>  </HEAD>")
     HtmlStream.WriteLine ("<BODY BGCOLOR=" & chHK & "gray" & chHK & ">")
     HtmlStream.WriteLine ("<script language=" & chHK & "JavaScript" & chHK & ">")
     HtmlStream.WriteLine ("window.moveTo (0, 0)")
     HtmlStream.WriteLine ("window.outerHeight = screen.availHeight")
     HtmlStream.WriteLine ("window.outerWidth = screen.availWidth")

     HtmlStream.WriteLine ("if (window.innerHeight)")
     HtmlStream.WriteLine (" js_h=window.innerHeight-20;")
     HtmlStream.WriteLine ("else")
     HtmlStream.WriteLine (" js_h=window.outerHeight-150;")

     HtmlStream.WriteLine ("document.write(" & chHK & "<A HREF='" & "../" & fFile.Name & "'> <IMG SRC='" & "../" & fFile.Name & "' ALT='Zoom (" & fFile.Name & ")' ALIGN=LEFT BORDER=0 HEIGHT=" & chHK & " + js_h + " & chHK & "> </A>" & chHK & ")")
     HtmlStream.WriteLine ("</script>")

     HtmlStream.WriteLine ("<DIV ALIGN=right><TABLE>")

     ' Wenn nicht erstes Bild, dann Link auf voriges Bild einfgen, sonst nur Dummy
     if (j > 1) then
         HtmlStream.WriteLine ("<TR><TD><A HREF=" & chHK & LEFT (strSorted (j-1), LEN(strSorted(j-1))-4) & ".html" & chHK &  "><IMG SRC=" & chHK & strLeftPic & chHK & " ALT=" & chHK & "<" & chHK & " NOSAVE BORDER=0 HEIGHT=34 WIDTH=34></A></TD>")
         HtmlStream.WriteLine ("<TD><FONT FACE=" & chHK & "Comic Sans MS" & chHK & "><FONT SIZE=0>Voriges Bild</FONT></FONT></TD></TR>")
     else
         HtmlStream.WriteLine ("<TR><TD><IMG SRC=" & chHK & strDummyPic & chHK & ">" & "</TD></TR>")
     end if
     
     ' Wenn nicht letztes Bild, dann Link auf nchstes Bild einfgen
     if (j < strAnz) then
         HtmlStream.WriteLine ("<TR><TD><A HREF=" & chHK & LEFT (strSorted (j+1), LEN(strSorted(j+1))-4) & ".html" & chHK &  "><IMG SRC=" & chHK & strRightPic & chHK & " ALT=" & chHK & ">" & chHK & " NOSAVE BORDER=0 HEIGHT=34 WIDTH=34></A></TD>")
         HtmlStream.WriteLine ("<TD><FONT FACE=" & chHK & "Comic Sans MS" & chHK & "><FONT SIZE=0>N&auml;chstes Bild</FONT></FONT></TD></TR>")
     end if

     ' Link auf Indexdatei einfgen
     HtmlStream.WriteLine ("<TR><TD><A HREF=" & chHK & "../" & strIndexName & chHK & "><IMG SRC=" & chHK & strIndexPic & chHK & " ALT=" & chHK & "Index" & chHK & " NOSAVE BORDER=0 HEIGHT=34 WIDTH=34></A></TD>")
     HtmlStream.WriteLine ("<TD><FONT FACE=" & chHK & "Comic Sans MS" & chHK & "><FONT SIZE=0>Zum Index</FONT></FONT></TD></TR>")

     ' Link auf 1:1-Bild einfgen (Zoom)
     HtmlStream.WriteLine ("<TR><TD><A HREF=" & chHK & "../" & strSorted(j) & chHK & "><IMG SRC=" & chHK & strZoomPic & chHK & " ALT=" & chHK & "Zoom" & chHK & " NOSAVE BORDER=0 HEIGHT=34 WIDTH=34></A></TD>")
     HtmlStream.WriteLine ("<TD><FONT FACE=" & chHK & "Comic Sans MS" & chHK & "><FONT SIZE=0>Zoomen</FONT></FONT></TD></TR>")

     HtmlStream.WriteLine ("</TABLE>")

     ' Datei-Info einfgen
     HtmlStream.WriteLine ("<FONT FACE=" & chHK & "Comic Sans MS" & chHK & "><FONT SIZE=-2>")
     HtmlStream.WriteLine ("<BR>")
     HtmlStream.WriteLine ("Datum:")
     HtmlStream.WriteLine ("<BR>")
     HtmlStream.WriteLine (Mid (strSorted(j), 5, 2)  & "." & Mid (strSorted(j), 3, 2) & "." & Left (strSorted(j),2) & "</TD></TR>")
     HtmlStream.WriteLine ("<BR><BR>")
     HtmlStream.WriteLine ("Uhrzeit:")
     HtmlStream.WriteLine ("<BR>")
     HtmlStream.WriteLine (Mid (strSorted(j), 8, 2) & ":" & Mid (strSorted(j), 10, 2) & "." & Mid (strSorted(j), 12, 2) & "</TD></TR>")

     HtmlStream.WriteLine ("</BODY>")
     HtmlStream.WriteLine ("</HTML>")
     HtmlStream.Close
Next

' Nach AVI- oder MOV-Dateien suchen und Index darauf anlegen, wenn gleichnamiges .JPG vorhanden
k = 0
For Each fFile in fPicFiles
  if (LCase(Right(fFile.Name, 4)) = ".avi") OR (LCase(Right(fFile.Name, 4)) = ".mov") Then 
    strTempName = (LEFT (fFile.Name, LEN(fFile.Name)-4) & ".jpg")

    ' Thumbnail mit Link nur erzeugen, wenn .JPG und .AVI vorhanden
    if (FS.FileExists (strTempName)) then

       ' Beim ersten gefundenen .AVI / .MOV eine berschrift "FILME" in _picindex.html anlegen
       if (k = 0) then
          TextStream.Write ("<hr WIDTH=" & chHK & "100%" & chHK & "><br>Filme:<br><br>")
       end if

       k = k + 1

       TextStream.Write ("<A HREF=" & chHK & fFile.Name)
       TextStream.Write (chHK & ">")
       TextStream.WriteLine (" ")

       TextStream.Write ("<IMG SRC=" & chHK)
       TextStream.Write (LEFT (fFile.Name, LEN(fFile.Name)-4) & ".jpg")
       TextStream.Write (chHK)

       TextStream.Write (" ALT=" & chHK)
       TextStream.Write (fFile.Name)
       TextStream.Write (" (Film ansehen)")
       TextStream.Write (chHK)

       TextStream.WriteLine (" BORDER=" & chHK & "0" & chHK & "></A>")
    end if
  end if
Next


' HTML-Nachspann in _PicIndex.html schreiben
TextStream.WriteLine("</center>")
TextStream.WriteLine("</body>")
TextStream.WriteLine("</html>")

TextStream.Close
' fDebug.Close

MsgBox "Es wurden " & strAnz & " Thumbnails und " & k & " Filme verarbeitet. Thumbnails ohne Original-Bild: " & strMissing & ".", vbInformation, "HTML Index Creator Script"
