' -------  CREATE_ROOT.VBS --------
'  Version: 25.5.2003
'
' Kleines VB-Script, das einen HTML-Index aller Unter-HTMLs _PICINDEX.HTML erstellt.
' (W) 4.2001, Henning Stcklein
'
' nderungen:
' 25.5.2003 : Alphabetisches Sortieren der Unterverzeichnisse, mit Y2K-Erkennung
'
Dim TextStream, HtmlStream
Dim chTab, chNL, chHK
Dim strIndexName
Dim strLeftPic, strRightPic, strZoomPic, strIndexPic
Dim strAnz, strMissing
Dim strPicPath, strIndexPath, strRootPath, strThumbFolder
Dim fFile, fThumbFirst

strThumbPath = "thumbnails"
strRootPath  = "."
strPicPath   = "."
strIndexPath = "../../index"
strIndexPath2 = "./index"
strIndexName = "_picindex.html"
strRootName = "index.html"
strBkndName = "bknd.jpg"
strLineName = "line.jpg"

chTab = chr(9)
chNL  = chr(10)
chHK  = chr(34)

Set FS = CreateObject("Scripting.FileSystemObject")
Set fPicFolder = FS.GetFolder(strPicPath)
Set fPicFiles = fPicFolder.Files
Set fRootFolder = FS.GetFolder(strRootPath)
Set fSubFolders = fRootFolder.SubFolders

' Dim strDebugName
' strDebugName = "debug.txt"
' Set fDebug = fPicFolder.CreateTextFile (strDebugName)

Dim strArray(5000)
Dim strSorted(5000)

' Alle untergeordneten Verzeichnisse nach _PICINDEX.HTML abscannen,
' damit Anzahl und alle Namen vorab bekannt sind.
i = 1
For each fFolder in fSubFolders
    strArray(i) = fFolder.Name

    ' Namen nur merken, wenn _PICINDEX.HMTL vorhanden
    if (FS.FileExists (fFolder.Name & "/" & strIndexName)) then
       i = i + 1

       ' Y2K-Sortierung: Bei Jahreszahlen mit "9." am Anfang "19" davorsetzen, sonst "20"
       if (Left(strArray(i-1), 1) = "9") then
          strArray(i-1) = "19" & strArray(i-1)
       else
          strArray(i-1) = "20" & strArray(i-1)
       end if

    end if
Next
strAnz = i-1


' Die Verzeichnisnamen umsortieren, in alphabetisch aufsteigende Reihenfolge bringen
for nSort = 1 to strAnz

   ' Den kleinsten Namen im unsortierten Array suchen
   nMerk = 0
   strMerk = "9999999"
'   fDebug.WriteLine ("*** New Run:" & nSort & "***")
   For j = 1 to strAnz
'      fDebug.WriteLine (j & " : " & strArray(j))
      if (StrComp (strArray(j), strMerk)) = -1 then
        nMerk = j
        strMerk = strArray(nMerk)
      end if
   Next

   ' Den gefundenen Namen ins sortierte Array einkopieren, dabei "19" bzw. "20" wieder entfernen
   strSorted(nSort) = (RIGHT(strMerk, LEN(strMerk)-2))
   strArray(nMerk) = "9999"		' Eintrag lschen
'   fDebug.WriteLine ("******************* Found @" & nMerk & " : " & strMerk)
Next 

Set TextStream = fRootFolder.CreateTextFile (strRootName)

' HTML-Header schreiben
TextStream.WriteLine ("<html>")
TextStream.WriteLine ("<head>")
TextStream.WriteLine ("<meta http-equiv=" & chHK & "Content-Type" & chHK & " content=" & chHK & "text/html; charset=iso-8859-1" & chHK & ">")
TextStream.WriteLine ("<meta name=" & chHK & "GENERATOR" & chHK & "content=" & chHK & "Hennings PicIndex-Generator" & chHK & ">")
TextStream.WriteLine ("<title>Root-Index</title>")
TextStream.WriteLine ("<style>")
TextStream.WriteLine ("body {font-family:Verdana;}")
TextStream.WriteLine ("</style>")
TextStream.WriteLine ("</head>")
TextStream.WriteLine ("<body bgcolor=" & chHK & "#C0C0C0" & chHK & " background=" & chHK & strIndexPath2 & "/" & strBkndName & chHK & ">")
TextStream.WriteLine ("<center>")
TextStream.WriteLine ("<font face=" & chHK & "Verdana" & chHK & "><font size=-1>")
TextStream.WriteLine ("</font></font>")

TextStream.WriteLine ("<TABLE BORDER WIDTH=" & chHK & "35%" & chHK & ">")
TabCol = 1

' Alle Unterordner mit Link auf _PICINDEX.HTML auflisten
For j = 1 to strAnz
  ' Erstes Thumbnail-Bild im Unterordner ermitteln
  strThumbFolder = strSorted(j) & "/" & strThumbPath
  Set fThumbFolder = FS.GetFolder(strThumbFolder)
  Set fThumbFiles = fThumbFolder.Files
  For Each fFile in fThumbFiles
     FThumbFirst = fFile.Name
     if (LCase(Right(fFile.Name, 6)) = "_t.jpg") then 
        Exit For
     end if
  Next

  ' Pro Verzeichnis einen Tabelleneintrag erstellen
  ' Linke Spalte
  if TabCol = 1 then
    TextStream.WriteLine ("<tr>")
  end if

  TextStream.WriteLine ("<td><a href=" & chHK & strSorted(j) & "/" & strIndexName & chHK & ">")
  TextStream.WriteLine ("<img src=" & chHK & strSorted(j) & "/" & strThumbPath & "/" & fThumbFirst & chHK & " NOSAVE BORDER=0 HEIGHT=80 WIDTH=80></A></TD>")
  TextStream.WriteLine ("<td><a href=" & chHK & strSorted(j) & "/" & strIndexName & chHK & "> " & strSorted(j) & " </a></td>")

  ' Doppel-Linie zwischen den Spalten erzeugen
  if TabCol < 3 then
    TextStream.WriteLine ("<td><img src=" & chHK & strIndexPath2 & "/" & strLineName & chHK & "></td>")
  end if

  ' Rechte Spalte
  if TabCol = 3 then
    TextStream.WriteLine ("</tr>")
  end if

  ' Spaltenzhler weitersetzen
  TabCol = TabCol + 1
  if TabCol = 4 then
     TabCol = 1
  end if
Next

TextStream.WriteLine ("</table>")

' HTML-Nachspann in _Index.html schreiben
TextStream.WriteLine("</center>")
TextStream.WriteLine("</body>")
TextStream.WriteLine("</html>")

TextStream.Close
' fDebug.Close

MsgBox "Es wurden " & strAnz & " Index-Dateien verarbeitet.", vbInformation, "HTML Root Creator Script"
